
function Dfe22000_DetalhamentoNotasFiscaisManifestada_Controller(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService) {
	
    
    var CDEMPRESA;
    
        this.empresaOnChange = (widget) => {
        let cnpj = widget.getField("NRINSJURIEST");
        let cnpjFilter = cnpj.dataSourceFilter.find(data => data.name === 'CDEMPRESA');
        
        if(widget.currentRow.CDEMPRESA) cnpjFilter.value = widget.currentRow.CDEMPRESA; 
        
        cnpj.readOnly = !widget.currentRow.CDEMPRESA;
        cnpj.setValue('');
    };
    
	this.validaParamFilter = function (widget){
        var dataAtual = moment().format('MM/YYYY');
        var rowFilter = {};
        rowFilter.DTINSNRNSU = dataAtual;
    
 	    
 	    General.callRestEngine("df#/crud/filial", "FilterData", [{name: "CDFILIAL", operator:"=", value: "FILIAL_LOGADA"}]).then((response) => {
 	        if(response.dataset.filial[0]) {
 	            rowFilter.CDFILIAL  = response.dataset.filial[0].CDFILIAL;
 	            rowFilter.NMFILIAL  = response.dataset.filial[0].NMFILIAL;
 	        }
            ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
 	    },
 	    (error) => {
 	        ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
            
 	    });
    };
    
    var getNumeracaoTransmissaoNfeWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget('detalhamentoManifestacao');
    };
    this.getDefaultFilter = function(args) {
    	
        var pai        = getNumeracaoTransmissaoNfeWidget();
        var currentRow = pai.dataSourceFilter;
        var gridAmbiente = "detalhamento_notas_fiscais_manifestada";
        
        var row        = {NRORG: currentRow[3].value, NRINSJURIEST: currentRow[4].value, IDAMBIENTENFE: currentRow[6].value, DTINSNRNSU: currentRow[5].value};
        
        General.callRestEngine("df_relatorios#/findNrNSU", "Row", row).then(success => {
            let nsuNfe = success.dataset.findNrNSU;
            
          
            let seqNSU = [];
            let rowNovoCodigo = [];
            
            nsuNfe.forEach(el => {
                let objNovoCodigo = {NRACESSONFE: el.NRACESSONFE};
                seqNSU.push(objNovoCodigo);
            });
            
            General.callRestEngine("df_relatorios#/findHistNSU", "Row", seqNSU).then(success => {
                let dataSetNovoCodigo = success.dataset.NumeracaoNovoCodigo;
                
                dataSetNovoCodigo.forEach(el => {
                    novoCodigoDb.push(el);
                });
                
                seqSerie.forEach(elSerie => {
                    novoCodigoDb.forEach(elNovoCodigo => {
                        if(elNovoCodigo.SERIENFE == elSerie.CDSERIENFE) {
                            let obj = {
                                CDEMPRESA: elSerie.CDEMPRESA, 
                                CDSERIENFE: elSerie.CDSERIENFE, 
                                CDINSCESTA: elSerie.CDINSCESTA, 
                                IDTPAMBIENTENFE: elSerie.IDTPAMBIENTENFE,
                                IDTIPOEMISNFE: elSerie.IDTIPOEMISNFE, 
                                NRINSJURIEST: elSerie.NRINSJURIEST, 
                                CDINSCMUNI: elSerie.CDINSCMUNI, 
                                CDSERIE: elSerie.CDSERIE, 
                                DSSERIE: elSerie.DSSERIE, 
                                SERIENFE: elNovoCodigo.SERIENFE, 
                                NRSEQUENCIAL: elNovoCodigo.NRSEQUENCIAL, 
                                NRSEQUENCIALORI: elNovoCodigo.NRSEQUENCIAL, 
                                TPAMBIENTE: elNovoCodigo.TPAMBIENTE, 
                                CDCONTADOR: elNovoCodigo.CDCONTADOR,
                                NMOPERADOR: P_NMOPERADOR, 
                                CDOPERADOR: P_CDOPERADOR};
                            serieFinal.push(obj);
                        }
                    });
                });
            
                let child = getNumeracaoTransmissaoNfeWidget().container.getWidget('Ambiente');
                child.dataSource.setData(serieFinal);
                child.reload();
                pai.reload();
            });
        });
    };

}

Configuration(function(ContextRegister) {
	ContextRegister.register('Dfe22000_DetalhamentoNotasFiscaisManifestada_Controller', Dfe22000_DetalhamentoNotasFiscaisManifestada_Controller);
});
